///--------------------------------------------------------------------
// loadString
// A function for loading strings
// To aid with internationalization
// 
// Another file must exist with an associative array named 
// StringTable.  It must be included by any file using loadString
//
// Created by Nik Spilka 12/13/2001
// Modified by Joe Chen Nov 14, 2003
// -------------------------------------------------------------------
var StringTable = new Array();

//
// The first language MUST be the default language. See getBrowserLangCode
// for details.
//
var SupportedLanguages  = new Array("en", "fr", "de", "it", "nl", "es", "sv", "ja", "zs", "zt", "pt");
var bUseStaticLangFile = true;
var theLang = getBrowserLangCode();

function loadString( strIdentifier ){
	document.write (StringTable[strIdentifier]);
}

//----------------------------------------------------------------------
// Works just like loadString, but returns a value instead of writing
//----------------------------------------------------------------------
function loadStringValue(strIdentifier){
	return StringTable[strIdentifier];
}


function stringTableUndefined (){
	return isUndefined(StringTable);
}

function isUndefined(value)
{
  var undef;
  return value == undef;
} 

function getBrowserLangCode()
{
	var langCode;

	if (navigator.language != null)
		langCode = navigator.language.substr(0,2);
	else if(navigator.userLanguage != null)
		langCode = navigator.userLanguage.substr(0,2);
	else if(navigator.browserLanguage != null)
		langCode = navigator.browserLanguage.substr(0,2);

	if(langCode != null) {
		for(index in SupportedLanguages) {
			if(langCode == SupportedLanguages[index])
				return langCode;
		}
	}

	return SupportedLanguages[0];
}


