///--------------------------------------------------------------------
// loadString
// A function for loading strings
// To aid with internationalization
// 
// Another file must exist with an associative array named 
// StringTable.  It must be included by any file using loadString
//
// Created by Nik Spilka 12/13/2001
// Modified by Joe Chen Nov 14, 2003
// -------------------------------------------------------------------
var StringTable = new Array();
var SupportedLanguages  = new Array();
var bUseStaticLangFile = true;;
var theLang = getBrowserLangCode();

SupportedLanguages["de"] = true;
SupportedLanguages["en"] = true;
SupportedLanguages["es"] = true;
SupportedLanguages["fr"] = true;
SupportedLanguages["it"] = true;
SupportedLanguages["nl"] = true;
SupportedLanguages["sv"] = true;

function loadString( strIdentifier ){
	document.write (StringTable[strIdentifier]);
}

//----------------------------------------------------------------------
// Works just like loadString, but returns a value instead of writing
//----------------------------------------------------------------------
function loadStringValue(strIdentifier){
	return StringTable[strIdentifier];
}


function stringTableUndefined (){
	return isUndefined(StringTable);
}

function isUndefined(value)
{
  var undef;
  return value == undef;
} 

function getBrowserLangCode()
{
	var langCode;
	if (navigator.appName=='Netscape'){
		langCode = navigator.language;
	}
	else {
		langCode = navigator.browserLanguage;
	}

	// Get 2 char code
	langCode = langCode.substr(0,2);
	if (SupportedLanguages[langCode]==false)
	{
		langCode = "en";
	}
	
	return langCode;
}


