/**sfh
******************************************************************************

		params
	~~~~~~~~~~~~~~
		 
		Defines two objects:
		
			ParamsObject - utility for parsing query string for name/value pairs.
			
			CookieObject - utility for parsing cookies for name/value pairs.

******************************************************************************
efh*/

function GetParamsObject()
{
	if (!GetParamsObject.params)
	{
		GetParamsObject.params = new ParamsObject();
	}
	return GetParamsObject.params;
}

function CreateCookieMgrObject(cookiesSource)
{
	return new CookieMgrObject(cookiesSource);
}

//
// Utility object used by ParamsObject
//
function Param(n,v) { this.name=n;this.value=v; }

//
// ParamsObject contains utility methods for parsing query strings.
//
function ParamsObject()
{
	//
	// Statics
	//
	//var sSecurityChars ="<>\"\';)(&";
	
	//
	// Vars
	//
	var that = this;
	
	function getLocation() 
	{ 
		return document.location;
	}
	
	this.GetParamWithDefault = function(name,def)
	{
		if (!def) { def = ""; }
		var out = that.GetParam(name);
		if (!out) { out = def; }
		return out;
	};
	
	function sToParams(ssin,p) 
	{
	    p.length=0;
	    if(!ssin) { return; }
	    var ss = new String(ssin);
	    var i = ss.indexOf("?") + 1;
	    var bEsc = false;
	    if(i<=0) 
	    {
	        i=ss.indexOf("%3F");
	        if (i < 0) {return;}
	        i += 3;
	        bEsc = true;
	    }
	    var j, k, pm, str;
	    var bDone=false;
	    var nSkip;
	    while (!bDone) 
	    {
	        j=ss.indexOf("&",i); 
	        nSkip = 1;
	        if (j < 0) 
	        {
	            j = ss.indexOf("%26", i);
	            nSkip = 3;
	            if (j < 0) { j=ss.length; bDone=true; }
	        }
	        str=ss.substring(i,j);
	        k=str.indexOf("="); if(k<0) {k=str.length-1;}
	        pm = new Param(unescape(str.substring(0,k)), unescape(str.substring(k+1,str.length)));
	        p[p.length] = pm;
	        i = j + nSkip;
	    }
	}
	
	function jsSecurityEscape(pvalue)
	{
	   var sValue = unescape(pvalue);
	   var objRegex = new RegExp("[<>\"\';)(]", "g");
	   sValue = sValue.replace(objRegex,"");
	   return sValue;
	}
	
	function paramsToS(p, bEnc) {
	    var s = (bEnc ? "%3F" : "?");
		var bFirst=true;
	    for(var i=0;i<p.length;i=i+1)
	    {
	        if (p[i].name) { s+=(bFirst?"":"&")+escape(p[i].name)+"="+escape(p[i].value); bFirst=false;}
	    }
		return (s == (bEnc ? "%3F" : "?"))?"":s;
	}
	function getPm(p,name) 
	{
		var pm=null;
	    for (var i=0;i<p.length;i=i+1) 
	    {
	    	if (p[i].name==name) {pm=p[i];}
	    }
	   	return pm;
	}
	
	function getParam(p,name) 
	{
	    var pm = getPm(p,name);
	    return (pm?pm.value:"");
	}
	
	
	function setParam(p,name,val) 
	{
	    var pm = getPm(p,name);
	    if(pm) 
	    {
	        if (val) {pm.value=val;}
	        else {pm.name="";}
	    }
	    else if (val) { pm = new Param(name,val); p[p.length]=pm; }
	}
	
	function replaceAll(strBase,strIn, strOut )
	{
		var iSrt=0;
		var iFin=0;
		while (iSrt< strBase.length){
		    iFin = strBase.indexOf(strIn, iSrt);
		    if (iFin < 0) {iFin = strBase.length;}
		    strBase = strBase.replace(strIn, strOut);
			iSrt= iFin+1;
		}
		return strBase;
	}
	
	function getCurUrlFullPath() //returns protocol:port/xx/xx/"
	{
		var loc = getLocation();
		var pathname = loc.pathname;
		pathname = replaceAll(pathname, "\\", "/"); //in file:// url, pathname contains "\\"
		var i = loc.href.indexOf(pathname);
		var j = pathname.lastIndexOf("/");
		var sRoot = loc.href.substring(0, i + j + 1);
		return sRoot;
	}
	
	// automatically get the URL param set ...
	var searchParams = new Array;
	sToParams(getLocation(), searchParams);
	
	// a convenient API ...
	this.GetParam = function(name) { return getParam(searchParams,name); };
	this.GetParamL = function(name) { var str = getParam(searchParams,name); return str.toLowerCase(); };
	this.SetParam = function(name, val) { setParam(searchParams, name, val);  };
	this.ClearParam = function(name) { setParam(searchParams, name, null); };
	this.ParamsToS = function() { return paramsToS(searchParams, false); };
	this.PullParam = function(name) { var str = that.GetParam(name); that.ClearParam(name); return str; };
	this.isTrue = function(s) {  var t = s.toLowerCase(); return (t=='t'||t=='true'||t=='1'); };
	this.AddParams = function(url) { return url + paramsToS(searchParams, needIE4Fix(url)); };
	function urlWithParams(url) 
	{
	    var arg = 1;
	    var name;
	    var value;
	    var bFirst = true;
	    while (arg < urlWithParams.arguments.length) 
	    {
	        name = urlWithParams.arguments[arg];
	        arg = arg + 1;
			if (arg < urlWithParams.arguments.length)
			{
				value = urlWithParams.arguments[arg];
				arg = arg + 1;
			}
			else
			{
				value = "";
			}
	        if (name) 
	        {
	            url += (bFirst ? searchChar(url) : "&") + name + "=" + escape(value);
	        }
	        bFirst = false;
	    }
	    return url;
	}
	// IE4 does not accept '?' in a relative URL when in file: protocol
	function searchChar(url) { return (needIE4Fix(url) ? "%3F" : "?"); }
	function hasFileProtocol(url) { return url.indexOf("file:") === 0; }
	function isRelative(url) { return url.indexOf(":") < 0; }
	function isIE4() 
	{
		var browserName = navigator.appName;
		var isIE = (browserName.toLowerCase().indexOf("internet") != -1);
		if (!isIE) {return false;}
	
		var bIsIE4 = false;
		var IEVersionPrefix = "msie ";
		var sBrowserVersion = navigator.appVersion.toLowerCase();
		var indexVer = sBrowserVersion.indexOf(IEVersionPrefix );
		if (indexVer == -1)
		{
			bIsIE4 = true;
		}
		else
		{
			var Ver = 0;
			sBrowserVersion = sBrowserVersion.substring(indexVer + IEVersionPrefix.length);
			Ver = parseInt("0"+ parseInt(sBrowserVersion));
			bIsIE4 = (Ver <= 4);
		}
		return bIsIE4 ;
	}
	function needIE4Fix(url) 
	{ 
		var loc = getLocation();
		return (isIE4() && hasFileProtocol(loc.href) && isRelative(url)); 
	}

} // End of ParamsObject

//
// CookieMgrObject contains utility methods for parsing cookies.
//
function CookieMgrObject(cookiesSource)
{
	/*sfh
	******************************************************************************
	
		Function:		SetPersistentCookie
	
		Desc:			Sets the specified cookie name/value. Future requests
						to the current document's domain will include this
						cookie name/value. Persistent cookies are stored up until
						their expiry date.
	
		Returns:		void
	
	******************************************************************************
	efh*/

	this.SetPersistentCookie = function(name, value)
	{
		var exp = new Date();
		exp.setHours(exp.getHours() + 2);
		
		if (value === null) { value = ""; }
		
		m_cookies[name] = value;
		document.cookie = name + "=" + escape(value) + "; expires=" + exp.toGMTString();
	};

	/*sfh
	******************************************************************************
	
		Function:		SetSessionCookie
	
		Desc:			Sets the specified cookie name/value. Future requests
						to the current document's domain will include this
						cookie name/value. Session cookies are automatically 
						deleted when the browser is closed.
	
		Returns:		void
	
	******************************************************************************
	efh*/

	this.SetSessionCookie = function(name, value)
	{
		if (value === null) { value = ""; }
		
		m_cookies[name] = value;
		document.cookie = name + "=" + escape(value) + ";";
	};

	/*sfh
	******************************************************************************
	
		Function:		GetCookie
	
		Desc:			Returns the cookie value with the specified name.
	
		Returns:		string
	
	******************************************************************************
	efh*/

	this.GetCookie = function(name)
	{
		var ret = m_cookies[name];
		if (typeof ret == "undefined" || ret === null)
		{
			ret = "";
		}
		return ret;
	};

	/*sfh
	******************************************************************************
	
		Function:		GetCookieWithDefault
	
		Desc:			Returns the cookie value with the specified name, or the
						supplied default value if the cookie does not exist or
						has an empty value.
	
		Returns:		string
	
	******************************************************************************
	efh*/

	this.GetCookieWithDefault = function(name, def)
	{
		var ret = m_cookies[name];
		if (typeof ret == "undefined" || ret === null)
		{
			ret = def;
		}
		return ret;
	};

	/*sfh
	******************************************************************************
	
		Function:		GetCookieIntWithDefault
	
		Desc:			Returns the cookie value with the specified name, or the
						supplied default value if the cookie does not exist or
						has an empty value.
						
						The returned value is converted to an int.
	
		Returns:		int
	
	******************************************************************************
	efh*/

	this.GetCookieIntWithDefault = function(name, def)
	{
		var ret = m_cookies[name];
		if (typeof ret == "undefined" || ret === null)
		{
			ret = def;
		}
		
		try
		{
			ret = parseInt(ret);
		}
		catch(e)
		{
			ret = def;
		}
		return ret;
	};

	/*sfh
	******************************************************************************
	
		Function:		GetCookieBool
	
		Desc:			Returns true or false based on the cookie value with 
						the specified name. The cookie value is converted to 
						bool.  Supported values are (not case sensitive):
							1, 0, t, f, y , n, true, false, yes, no
						
						Unsupported values are false.
	
		Returns:		bool
	
	******************************************************************************
	efh*/

	this.GetCookieBool = function(name)
	{
		var bRet = false;
		var value = m_cookies[name];
		if (value === "1" || value === "t" || value === "T" || value === "y" || value === "Y" || 
		    value === "true" || value === "TRUE" || value === "yes" || value === "YES")
		{
			bRet = true;
		}
		return bRet;
	};

	/*sfh
	******************************************************************************
	
		Function:		DeleteCookie
	
		Desc:			Deletes the specified cookie.
	
		Returns:		void
	
	******************************************************************************
	efh*/

	this.DeleteCookie = function(name)
	{
		var exp = new Date();
		exp.setFullYear(1970,1,1);
		
		m_cookies[name] = null;

		// First try deleting as a session cookie, then as a persistent cookie.
		document.cookie = name + "=;";
		document.cookie = name + "=;" + " expires=" + exp.toGMTString();
	};

	/*sfh
	******************************************************************************
	
		Function:		DeleteAllCookies
	
		Desc:			Deletes all cookies.
	
		Returns:		void
	
	******************************************************************************
	efh*/

	this.DeleteAllCookies = function(name)
	{
		var exp = new Date();
		exp.setFullYear(1979,1,1);
		
		for (var n in m_cookies) 
		{
			// First try deleting as a session cookie, then as a persistent cookie.
			document.cookie = n + "=;";
			document.cookie = n + "=;" + " expires=" + exp.toGMTString();
		}
		m_cookies = new Object();
	};

	/*sfh
	******************************************************************************
	
		Function:		ToString
	
		Desc:			Dumps the cookie list to a string.
	
		Returns:		string
	
	******************************************************************************
	efh*/

	this.ToString = function()
	{
		var str = "";
		
		for (var n in m_cookies) 
		{
			str = str + n + "=" + m_cookies[n] + "; ";
		}
		return str;
	};

	/*sfh
	******************************************************************************
	
		Function:		ExtractCookies
	
		Desc:			Parses the source cookie object (usually from
						document.cookies) and returns an array of name/value
						pairs.
	
		Returns:		array object
	
	******************************************************************************
	efh*/

	function ExtractCookies(cookiesSource)
	{
		var cookies = new Object();
		if (!cookiesSource) { return cookies; }

		var name;
		var value;
		var beginning = 0;
		var middle;
		var end;
		while (beginning < cookiesSource.length)
		{
			middle = cookiesSource.indexOf('=', beginning);
			end = cookiesSource.indexOf(';', beginning);
			if (end == -1)
			{
				end = cookiesSource.length;
			}
	
			if ( (middle > end) || (middle == -1) )
			{
				name = cookiesSource.substring(beginning, end);
				value = "";
			}
			else
			{
				name = cookiesSource.substring(beginning, middle);
				value = cookiesSource.substring(middle + 1, end);
			}
			cookies[name] = unescape(value);
			beginning = end + 2;
		}
		return cookies;
	}

	//
	// Vars
	//
	var m_cookies = ExtractCookies(cookiesSource);

} // End of CookieMgrObject

// End of file